/*
Small Machine Problem #0
CS 241, Spring 2009
*/

#include <stdio.h>
#include <unistd.h>

#include "smp0.part1.h"
#include "smp0.part2.h"
#include "smp0.part3.h"

int main(int argc, char **argv)
{
	/* Parse the command line options with getopt()... */
	char opt = getopt(argc, argv, "123");

	/* String for use in case '2' of switch() */
	char *s;

	/* Call the function based on the comamnd line argument
	   found or print an error message if a valid option
	   was not found. */
	switch (opt)
	{
		case '1':
			part_one();
			break;

		case '2':
			print_string_with_dollar_terminator("abcdefg$hijklm$"); printf("\n");
			print_string_with_dollar_terminator("abc\0def$"); printf("\n");
			print_string_with_dollar_terminator("aabbcc$$"); printf("\n");
			print_string_with_dollar_terminator("orange and blue $ 2"); printf("\n");
			print_string_with_dollar_terminator("$"); printf("\n");

			printf("is_binary_safe() #1: %i\n", is_binary_safe("abc", 10));
			printf("is_binary_safe() #2: %i\n", is_binary_safe("abc", 1));
			printf("is_binary_safe() #3: %i\n", is_binary_safe("", 10));
			printf("is_binary_safe() #4: %i\n", is_binary_safe("", 0));

			printf("count_Illinois() #1: %i\n", count_Illinois(""));
			printf("count_Illinois() #2: %i\n", count_Illinois("Illinois"));
			printf("count_Illinois() #3: %i\n", count_Illinois("Illinois ILLINOIS illinois"));
			printf("count_Illinois() #4: %i\n", count_Illinois("... IllinoisIllinoisIllinois Illinois Illinois Illinois Illinois Illinois ... Illinois ..."));

			s = big_string("abc", "def", "ghi"); printf("big_string() #1: %s\n", s); free(s);
			s = big_string("aaa", "bbb", "ccc"); printf("big_string() #2: %s\n", s); free(s);
			s = big_string("a", "a", "");        printf("big_string() #3: %s\n", s); free(s);

			s = overlay_overlay("computer", "mputr", "putt", "putter"); printf("overlay_overlay() #1: %s\n", s); free(s);
			s = overlay_overlay("the quick brown fox jumped over the lazy dog", "dog treat", "the quick brown fox jumped over the lazy dog", "dog treat "); printf("overlay_overlay() #2: %s\n", s); free(s);
			s = overlay_overlay("", "", "", ""); printf("overlay_overlay() #1: %s\n", s); free(s);
			break;

		case '3':
			part_three();
			break;

		default:
			printf("Unknown options. Expected usage:\n");
			printf("  %s -1    Runs [Part 1]\n", argv[0]);
			printf("  %s -2    Runs [Part 2]\n", argv[0]);
			printf("  %s -3    Runs [Part 3]\n", argv[0]);
			return -1;
	}

	return 0;
}
